Index: branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IAnalyticalPTSPMoveEvaluator.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IAnalyticalPTSPMoveEvaluator.cs	(revision 16453)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IAnalyticalPTSPMoveEvaluator.cs	(revision 16477)
@@ -24,6 +24,8 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Problems.PTSP {
+  [StorableType("D503E92D-9A85-46AC-ADAA-8A454B9E9C79")]
   public interface IAnalyticalPTSPMoveEvaluator : IAnalyticalPTSPOperator, ISingleObjectiveMoveEvaluator, IPermutationMoveOperator {
     ILookupParameter<DoubleMatrix> CoordinatesParameter { get; }
Index: branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IAnalyticalPTSPOperator.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IAnalyticalPTSPOperator.cs	(revision 16453)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IAnalyticalPTSPOperator.cs	(revision 16477)
@@ -22,6 +22,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Problems.PTSP {
+  [StorableType("1BB8344B-894B-48E9-9805-49938AE3F83F")]
   public interface IAnalyticalPTSPOperator : IItem {
     ILookupParameter<DoubleArray> ProbabilitiesParameter { get; }
Index: branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IEstimatedPTSPMoveEvaluator.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IEstimatedPTSPMoveEvaluator.cs	(revision 16453)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IEstimatedPTSPMoveEvaluator.cs	(revision 16477)
@@ -24,6 +24,8 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Problems.PTSP {
+  [StorableType("FECFFE5C-64EE-4615-A9FC-786F2B37143A")]
   public interface IEstimatedPTSPMoveEvaluator : IEstimatedPTSPOperator, ISingleObjectiveMoveEvaluator, IPermutationMoveOperator {
     ILookupParameter<DoubleMatrix> CoordinatesParameter { get; }
Index: branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IEstimatedPTSPOperator.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IEstimatedPTSPOperator.cs	(revision 16453)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/IEstimatedPTSPOperator.cs	(revision 16477)
@@ -22,6 +22,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Problems.PTSP {
+  [StorableType("1998604C-41FF-4388-B413-8BD658D073E5")]
   public interface IEstimatedPTSPOperator : IItem {
     ILookupParameter<ItemList<BoolArray>> RealizationsParameter { get; }
Index: branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/ITwoPointFiveMoveOperator.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/ITwoPointFiveMoveOperator.cs	(revision 16453)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Problems.PTSP/3.3/Interfaces/ITwoPointFiveMoveOperator.cs	(revision 16477)
@@ -22,6 +22,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Problems.PTSP {
+  [StorableType("C21E0AC3-85BD-4F40-8DD6-E79A019278E1")]
   public interface ITwoPointFiveMoveOperator : IMoveOperator {
     ILookupParameter<TwoPointFiveMove> TwoPointFiveMoveParameter { get; }