Index: branches/2520_PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs	(revision 16477)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs	(revision 16479)
@@ -29,5 +29,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HEAL.Fossil;
 using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Problems.DataAnalysis.Symbolic;
Index: branches/2520_PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/Distances/DistanceBase.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/Distances/DistanceBase.cs	(revision 16477)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Algorithms.DataAnalysis/3.4/TSNE/Distances/DistanceBase.cs	(revision 16479)
@@ -25,5 +25,4 @@
 using HeuristicLab.Core;
 using HEAL.Fossil;
-using HEAL.Fossil;
 
 namespace HeuristicLab.Algorithms.DataAnalysis {
@@ -44,15 +43,21 @@
 
     public double Get(object x, object y) {
-      return Get((T) x, (T) y);
+      return Get((T)x, (T)y);
     }
 
     public IComparer GetDistanceComparer(object item) {
-      return new DistanceComparer((T) item, this);
+      return new DistanceComparer((T)item, this);
     }
 
     [StorableType("35fcecb5-9209-469b-9e4e-82efd8abfddf")]
     internal class DistanceComparer : IComparer<T>, IComparer {
+      [Storable]
       private readonly T item;
+      [Storable]
       private readonly IDistance<T> dist;
+
+      [StorableConstructor]
+      protected DistanceComparer(StorableConstructorFlag _) {
+      }
 
       public DistanceComparer(T item, IDistance<T> dist) {
Index: branches/2520_PersistenceReintegration/HeuristicLab.Scripting.Views/3.3/VariableStoreView.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Scripting.Views/3.3/VariableStoreView.cs	(revision 16477)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Scripting.Views/3.3/VariableStoreView.cs	(revision 16479)
@@ -35,4 +35,5 @@
 using HeuristicLab.Persistence.Default.Xml;
 using HeuristicLab.PluginInfrastructure;
+using System.IO;
 
 namespace HeuristicLab.Scripting.Views {
@@ -474,15 +475,18 @@
     private bool IsSerializable(KeyValuePair<string, object> variable) {
       Type type = null;
-      bool serializable;
+      bool serializable = false;
 
       if (variable.Value != null) {
         type = variable.Value.GetType();
         if (serializableLookup.TryGetValue(type, out serializable)) return serializable;
-        if (StorableClassAttribute.IsStorableClass(type)) return serializableLookup[type] = true;
-      }
-
-      var ser = new Persistence.Core.Serializer(variable, ConfigurationService.Instance.GetDefaultConfig(new XmlFormat()), "ROOT", true);
+        if (StorableTypeAttribute.IsStorableType(type)) return serializableLookup[type] = true;
+      }
+
+      var ser = new ProtoBufSerializer();
       try {
-        serializable = ser.Count() > 0; // try to create all serialization tokens
+        using (var memStream = new MemoryStream()) {
+          ser.Serialize(variable.Value, memStream); // try to serialize to memory stream
+          serializable = true;
+        }
       } catch (PersistenceException) {
         serializable = false;
Index: branches/2520_PersistenceReintegration/HeuristicLab.Selection/3.3/EvolutionStrategyOffspringSelector.cs
===================================================================
--- branches/2520_PersistenceReintegration/HeuristicLab.Selection/3.3/EvolutionStrategyOffspringSelector.cs	(revision 16477)
+++ branches/2520_PersistenceReintegration/HeuristicLab.Selection/3.3/EvolutionStrategyOffspringSelector.cs	(revision 16479)
@@ -33,13 +33,17 @@
   [StorableType("CE585C3C-5139-44F0-9CB2-CC901A290831")]
   public class EvolutionStrategyOffspringSelector : SingleSuccessorOperator {
-
+    [StorableType("F1CA99A7-E9C2-49F3-8030-5CEE407357AA")]
     private class FitnessComparer : IComparer<IScope> {
 
       #region IComparer<IScope> Member
-
-      private String qualityParameterName;
+      [Storable]
+      private string qualityParameterName;
+      [Storable]
       private bool maximization;
 
-      public FitnessComparer(String qualityParamName, bool maximization) {
+      [StorableConstructor]
+      protected FitnessComparer(StorableConstructorFlag _) { }
+
+      public FitnessComparer(string qualityParamName, bool maximization) {
         this.qualityParameterName = qualityParamName;
         this.maximization = maximization;