Index: /branches/2520_PersistenceReintegration/HeuristicLab.Analysis/3.3/DataVisualization/DataRowVisualProperties.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Analysis/3.3/DataVisualization/DataRowVisualProperties.cs	(revision 16482)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Analysis/3.3/DataVisualization/DataRowVisualProperties.cs	(revision 16483)
@@ -33,4 +33,5 @@
   public class DataRowVisualProperties : DeepCloneable, INotifyPropertyChanged {
     #region ChartType
+    [StorableType("488A018F-AF79-4B60-989A-845EF24F4A01")]
     public enum DataRowChartType {
       Line,
@@ -41,6 +42,8 @@
       StepLine
     }
+
     #endregion
     #region LineStyle
+    [StorableType("A064C2CE-D2CC-4292-B5FC-8DDCFA55C896")]
     public enum DataRowLineStyle {
       Dash,
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Analysis/3.3/DataVisualization/DataTableVisualProperties.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Analysis/3.3/DataVisualization/DataTableVisualProperties.cs	(revision 16482)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Analysis/3.3/DataVisualization/DataTableVisualProperties.cs	(revision 16483)
@@ -33,4 +33,5 @@
 
     #region Histogram Aggregation
+    [StorableType("323A07AD-207C-4D45-B7EC-4E3E48F1E5C6")]
     public enum DataTableHistogramAggregation {
       Overlapping,
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Common/3.3/Point2D.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Common/3.3/Point2D.cs	(revision 16482)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Common/3.3/Point2D.cs	(revision 16483)
@@ -31,5 +31,4 @@
     public static readonly Point2D<T> Empty = new Point2D<T>();
 
-    [Storable]
     private T x;
     public T X {
@@ -37,5 +36,4 @@
     }
 
-    [Storable]
     private T y;
     public T Y {
@@ -43,5 +41,4 @@
     }
 
-    [Storable]
     private object tag;
     public object Tag {
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Tests/HeuristicLab.Persistence.Fossil/UseCases.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Tests/HeuristicLab.Persistence.Fossil/UseCases.cs	(revision 16482)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Tests/HeuristicLab.Persistence.Fossil/UseCases.cs	(revision 16483)
@@ -166,8 +166,37 @@
       }
     }
-    
-    // TODO:
-    // - IndexedItem and IndexedDataTable
-    // - Point2D from HL.Common 
+
+    [TestMethod]
+    [TestCategory("Persistence.Fossil")]
+    [TestProperty("Time", "short")]
+    public void TestIndexedDataTable() {
+      var dt = new IndexedDataTable<int>("test", "test description");
+      var dr = new IndexedDataRow<int>("test row");
+      dr.Values.Add(Tuple.Create(1, 1.0));
+      dr.Values.Add(Tuple.Create(2, 2.0));
+      dr.Values.Add(Tuple.Create(3, 3.0));
+      dt.Rows.Add(dr);
+      var ser = new ProtoBufSerializer();
+      ser.Serialize(dt, tempFile);
+      var dt2 = (IndexedDataTable<int>)ser.Deserialize(tempFile);
+      Assert.AreEqual(dt.Rows["test row"].Values[0], dt2.Rows["test row"].Values[0]);
+      Assert.AreEqual(dt.Rows["test row"].Values[1], dt2.Rows["test row"].Values[1]);
+      Assert.AreEqual(dt.Rows["test row"].Values[2], dt2.Rows["test row"].Values[2]);
+    }
+
+    [TestMethod]
+    [TestCategory("Persistence.Fossil")]
+    [TestProperty("Time", "short")]
+    public void TestPoint2d() {
+      var tag = new IntValue(10);
+      var p = new Point2D<double>(1.0, 2.0, tag);
+      var ser = new ProtoBufSerializer();
+      ser.Serialize(p, tempFile);
+      var p2 = (Point2D<double>)ser.Deserialize(tempFile);
+      Assert.AreEqual(p.X, p2.X);
+      Assert.AreEqual(p.Y, p2.Y);
+      var tag2 = (IntValue)p2.Tag;
+      Assert.AreEqual(tag.Value, tag2.Value);
+    }
 
     [ClassInitialize]